/*
 * Created on Aug 31, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package components;

import java.awt.TextField;

import javax.swing.*;

import java.awt.event.*;

/**
 * @author rholguin
 *
 *This panel will give them the option of choosing to load the grid from a file or to randomly generate a grid.
 *If they choose to load a file then they will be directed to the main panel.  if they choose to generate a 
 *grid they will be presented with the tunable options for thier grid.
 */
public class OptionPanel extends JPanel implements ActionListener {
	
	private JFrame frame;
	private JButton file;
	private JButton random1;
	private JButton random2;
	
	private JLabel green;
	private TextField greenText;
	
	private JLabel red; 
	private TextField redText;
	
	private JLabel size;
	private TextField sizeText;
	
	private MyDialog dialog;
	
	private boolean finished = false;
	private boolean ran = false;
	
	private int[] randomParams = new int[3];
	
	
	public OptionPanel (JFrame f) {
		setLayout(null);
		frame = f;
		
		//create and set components
		file = new JButton("Load grid from File");
		file.setName("file");
		file.addActionListener(this);
		
		random1 = new JButton("Randomly generate grid");
		random1.setName("random1");
		random1.addActionListener(this);
		
		removeAll();
		
		add(file);
		add(random1);
		
		file.setBounds(100,200,file.getPreferredSize().width,file.getPreferredSize().height);
		random1.setBounds(480,200,random1.getPreferredSize().width,random1.getPreferredSize().height);
	}
	
	/*
	 * This will catch teh button presses and take the appropriate action
	 */
	public void actionPerformed(ActionEvent e) {
		if(((JButton)e.getSource()).getName().equals("file")) {
			finished = true;
			ran = false;
		}
		else if(((JButton)e.getSource()).getName().equals("random1")) {
			RandomDisplay();
		}
		else if(((JButton)e.getSource()).getName().equals("random2")) {
			randomParams[0] = new Integer(sizeText.getText()).intValue();
			randomParams[1] = new Integer(redText.getText()).intValue();
			randomParams[2] = new Integer(greenText.getText()).intValue();
			
			if (randomParams[1] > 100 || randomParams[1] < 0) {
				dialog = new MyDialog(frame,"Invalid Red number",false);
				dialog.setVisible(true);
			}
			else if (randomParams[2] > 100 || randomParams[2] < 0) {
				dialog = new MyDialog(frame,"Invalid Green number",false);
				dialog.setVisible(true);
			}
			else if(randomParams[1]+randomParams[2] > 100 || randomParams[1]+randomParams[2] < 0) {
				dialog = new MyDialog(frame,"Sum of red and green must be between 0 and 100",false);
				dialog.setVisible(true);
			}
			else {
				ran = true;
				finished = true;
			}
		}
	}
	
	public boolean Continue(){
		return finished;
	}
	
	public int[] getRandomParams() {
		return randomParams;
	}
	
	public boolean isRandom(){
		return ran;
	}
	
	/*
	 * If the user choose to generate a grid then this function will display the interface
	 */
	private void RandomDisplay () {
		removeAll();
		
		green = new JLabel("Green Population (%)");
		greenText = new TextField("35");
		
		red = new JLabel("Red Population (%)");
		redText = new TextField("35");
		
		size = new JLabel("Grid size: ");
		sizeText = new TextField("6");
		
		random2 = new JButton("Submit");
		random2.setName("random2");
		random2.addActionListener(this);
		
		add(green);
		add(greenText);
		add(red);
		add(redText);
		add(size);
		add(sizeText);
		add(random2);
		
		green.setBounds(250,50,green.getPreferredSize().width, green.getPreferredSize().height);
		greenText.setBounds(380,50,30,20);
		sizeText.setBounds(150,50,30,20);
		size.setBounds(90,50,size.getPreferredSize().width, size.getPreferredSize().height);
		red.setBounds(480,50,red.getPreferredSize().width, red.getPreferredSize().height);
		redText.setBounds(590,50,30,20);
		random2.setBounds(320,120,random2.getPreferredSize().width,random2.getPreferredSize().height);
		
		repaint();
		paintComponents(this.getGraphics());
	}
}
