/*
 * Created on Jul 5, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package tools;

import java.awt.*;
import java.util.regex.Pattern;
import java.util.*;

import javax.swing.*;

/**
 * @author rholguin
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CreateGrid extends JPanel{

	private Map map;  //hash map of index -> color
	
    public CreateGrid (String[] model) {
        setLayout(new GridLayout(model.length,model.length));
        map = Collections.synchronizedMap(new HashMap()); 
        CreateColorMap();
        updateGrid(model);  
    }
    
    /*
     * This methodl will create the hashmap that maps an index value to a color
     * starting each color (R,G,B) at 50 and incrementing each value by 50 you will
     * have 4 values for each color (100,150,200,250).  so there are a total of 
     * 4^3 possible colors, 64
     */
    private void CreateColorMap() {
    	int R = 50;
		int G = 50;
		int B = 50;
		int index = 0;
		
		for(int x = 0; x < 5; x++) {
			for(int y = 0; y < 5; y++) {
				for(int z = 0; z < 5; z++) {
					if(x != 4 && y != 4 && z != 4) {
						map.put(new Integer(index++),new Color(R+x*50,G+y*50,B+z*50));
					}
				}
			}
		}
    }
    
    /*
     * This method will update the visual grid to represent the current status of the
     * grid
     */
    public void updateGrid(String model[]) {
    	removeAll();
    	
    	for(int x = 0; x < model.length; x++) {
    	    
    	    //parse the string into a temp variable
    		Pattern pattern = Pattern.compile("[\\s]*[\\s]");
			String[] temp = pattern.split(model[x]);
			
        	for(int y = 0; y < model.length; y++) {
        		Integer index = getIndexMap(new Integer(temp[y]));  //get index of current cell
        		Color color = null;
        		JPanel grid = null;
        		
        		//if index is 0 then default to white, else get color from the hashMap
        		if(index.intValue() == 0) {
        			color = Color.WHITE;
        		}
        		else {
        			color = (Color)map.get(index);
        		}
        		
        		//create a new grid panel and add it to the grid.
        		grid = new GridPanel(color);
    			grid.setBorder(BorderFactory.createLineBorder(Color.black));
    			add(grid);
        	}
        }
    	validate();  //refresh the panel to reflect the changes, prevents flickering
    }
    
    /*
     * This will convert the index value to make sure that it will map correctly to the color map.  If a value is more than
     * 64, then it will not map right.
     */
    private Integer getIndexMap(Integer i) {
        int temp = i.intValue();
        int indexFactor = (temp /64);
        
        //if the value is 80 then the new index would be 80 - 64*1 = 16...so 80 would map to the 16 on the color map
        Integer result = new Integer(temp - 64*indexFactor);
        return result;
    }
    
    //individual cells of the grid that will be set to the appropriate color
    private class GridPanel extends JPanel {
   
    	public GridPanel(Color color) {
        	setBackground(color);
        }
    }
}