/*
 * Created on Aug 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package tools;

import java.io.*;
import java.util.regex.Pattern;

public class ReadFile {
	
	private String[] cellGrid;  //holds the grid from the file
	private int numLines;  //size of the grid (numLines X numLines)
	
	private boolean[] Error = {false,false,false};
	
	public ReadFile() {
		try {
			FileReader reader = new FileReader("cells.txt");  //open file
			BufferedReader buff = new BufferedReader(reader);  //assign reader to the file handle
			
			String line = buff.readLine();  //first line should be numLines
			
			numLines = new Integer(line).intValue();
			cellGrid = new String[numLines];  //init cellGrid array to numLines
			
			int index = 0;
			
			//this will loop through every line in the file until there are no more lines left
			while((line = buff.readLine()) != null) {
			    //check to see if there are invalid characters in the string
				if(invalidChars(line)) {
					Error[2] = true;
					break;
				}
				//check to see if the size of the string is invalid
				else if(invalidSize(line,numLines)){
					Error[1] = true;
					break;
				}
				else {
				    //if the array goes out of bouunds then that means that the grid is bigger
				    //than expected. (ie: bigger than numLines)
					try {
						cellGrid[index++] = line;  //set array cell to string Line
					} catch (ArrayIndexOutOfBoundsException e) {
					    System.out.print(index);
						Error[1] = true;
					}
				}
			}
		} catch (IOException e) {
			Error[0] = true;  //cells.txt does not exist
		}
	}
	
	public String[] getGrid() {
		return cellGrid;
	}
	
	
	/*
	 * If any of the error flags are set then return the appropriate error string
	 */
	public String getError() {
		if(Error[0]) {
			return "File was not found, looking for cells.txt";
		}
		else if(Error[1]) {
			return "Grid format is not a perfect square";
		}
		else if(Error[2]) {
			return "Grid has an invalid character, valid characters are only integers";
		}
		else 
			return null;
	}
	
	/*
	 * This will check to see if the size of the grid is bigger than the size specified in the
	 * file
	 */
	private boolean invalidSize(String check, int size) {
    	Pattern pattern = Pattern.compile("[\\s]*[\\s]");
		String[] temp = pattern.split(check);
			
			
		if(temp.length > size) {
			return true;
		}
		return false;
	}
	
	/*
	 * This will go through every character in the inputted string and make sure
	 * that every charcater in the string is a Digit.
	 */
	private boolean invalidChars(String check) {
    		Pattern pattern = Pattern.compile("[\\s]*[\\s]");
			String[] temp = pattern.split(check);
			
			for(int y = 0; y < temp.length; y++) {
				for(int z = 0; z < temp[y].length(); z++) {
					if(!Character.isDigit(temp[y].charAt(z))) {
						return true;
					}
				}
			}
		return false;
	}
}
